
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
      <link rel="icon" href="../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.3.0, mkdocs-material-8.5.4">
    
    
      
        <title>Core concepts - Eclipse Hawk™</title>
      
    
    
      <link rel="stylesheet" href="../../assets/stylesheets/main.80dcb947.min.css">
      
        
        <link rel="stylesheet" href="../../assets/stylesheets/palette.cbb835fc.min.css">
        
          
          
          <meta name="theme-color" content="#7e56c2">
        
      
      

    
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
      <link rel="stylesheet" href="../../stylesheets/extra.css">
    
    <script>__md_scope=new URL("../..",location),__md_hash=e=>[...e].reduce((e,_)=>(e<<5)-e+_.charCodeAt(0),0),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
    
<!-- FAVICON -->
<link rel="apple-touch-icon" sizes="180x180" href="../../assets/images/apple-touch-icon.png">
<link rel="icon" type="image/png" sizes="32x32" href="../../assets/images/favicon-32x32.png">
<link rel="icon" type="image/png" sizes="16x16" href="../../assets/images/favicon-16x16.png">
<link rel="mask-icon" href="../../assets/images/safari-pinned-tab.svg" color="#5bbad5">
<link rel="shortcut icon" href="../../assets/images/favicon.ico">
<meta name="msapplication-TileColor" content="#b91d47">
<meta name="msapplication-config" content="../../assets/images/browserconfig.xml">
<meta name="theme-color" content="#ffffff">

  </head>
  
  
    
    
    
    
    
    <body dir="ltr" data-md-color-scheme="" data-md-color-primary="deep-purple" data-md-color-accent="deep-purple">
  
    
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#core-concepts-and-general-usage" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

<header class="md-header" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Header">
    <a href="../.." title="Eclipse Hawk™" class="md-header__button md-logo" aria-label="Eclipse Hawk™" data-md-component="logo">
      
  <img src="../../assets/images/hawk-logo-white.svg" alt="logo">

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            Eclipse Hawk™
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              Core concepts
            
          </span>
        </div>
      </div>
    </div>
    
    
    
      <label class="md-header__button md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" title="Clear" aria-label="Clear" tabindex="-1">
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header__source">
        <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2022 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    Git repository @ Eclipse
  </div>
</a>
      </div>
    
  </nav>
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
          
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


<nav class="md-nav md-nav--primary" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="../.." title="Eclipse Hawk™" class="md-nav__button md-logo" aria-label="Eclipse Hawk™" data-md-component="logo">
      
  <img src="../../assets/images/hawk-logo-white.svg" alt="logo">

    </a>
    Eclipse Hawk™
  </label>
  
    <div class="md-nav__source">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2022 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    Git repository @ Eclipse
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      

  
  
  
    <li class="md-nav__item">
      <a href="../.." class="md-nav__link">
        Home
      </a>
    </li>
  

    
      
      
      

  
  
    
  
  
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_2" type="checkbox" id="__nav_2" checked>
      
      
      
      
        <label class="md-nav__link" for="__nav_2">
          Basic use
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Basic use" data-md-level="1">
        <label class="md-nav__title" for="__nav_2">
          <span class="md-nav__icon md-icon"></span>
          Basic use
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../installation/" class="md-nav__link">
        Installation
      </a>
    </li>
  

            
          
            
              
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" data-md-toggle="toc" type="checkbox" id="__toc">
      
      
        
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          Core concepts
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        Core concepts
      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#components" class="md-nav__link">
    Components
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#general-usage" class="md-nav__link">
    General usage
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#managing-indexes-with-the-hawk-view" class="md-nav__link">
    Managing indexes with the Hawk view
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#creating-a-new-index" class="md-nav__link">
    Creating a new index
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#managing-metamodels" class="md-nav__link">
    Managing metamodels
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#managing-repositories" class="md-nav__link">
    Managing repositories
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#managing-indexed-attributes" class="md-nav__link">
    Managing indexed attributes
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#managing-derived-attributes-and-references" class="md-nav__link">
    Managing derived attributes and references
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#querying-the-graph" class="md-nav__link">
    Querying the graph
  </a>
  
    <nav class="md-nav" aria-label="Querying the graph">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#resolving-ambiguous-names" class="md-nav__link">
    Resolving ambiguous names
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#limiting-query-scope" class="md-nav__link">
    Limiting query scope
  </a>
  
    <nav class="md-nav" aria-label="Limiting query scope">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#path-based-scope" class="md-nav__link">
    Path-based scope
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#tree-based-scope" class="md-nav__link">
    Tree-based scope
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#traversal" class="md-nav__link">
    Traversal
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../examples-xmi/" class="md-nav__link">
        Examples (XMI)
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../examples-modelio/" class="md-nav__link">
        Examples (Modelio)
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../papyrus/" class="md-nav__link">
        Papyrus UML support
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_3" type="checkbox" id="__nav_3" >
      
      
      
      
        <label class="md-nav__link" for="__nav_3">
          Advanced use
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Advanced use" data-md-level="1">
        <label class="md-nav__title" for="__nav_3">
          <span class="md-nav__icon md-icon"></span>
          Advanced use
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/graph-as-emf/" class="md-nav__link">
        Graph as EMF model
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/advanced-props/" class="md-nav__link">
        Advanced properties
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/meta-queries/" class="md-nav__link">
        Meta-level queries
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/temporal-queries/" class="md-nav__link">
        Temporal queries
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/oomph/" class="md-nav__link">
        Oomph and Hawk
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_4" type="checkbox" id="__nav_4" >
      
      
      
      
        <label class="md-nav__link" for="__nav_4">
          Server
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Server" data-md-level="1">
        <label class="md-nav__title" for="__nav_4">
          <span class="md-nav__icon md-icon"></span>
          Server
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/architecture/" class="md-nav__link">
        Architecture
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/api/" class="md-nav__link">
        Thrift API
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/api-security/" class="md-nav__link">
        Thrift API security
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/deployment/" class="md-nav__link">
        Deployment
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/cli/" class="md-nav__link">
        Console client
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/eclipse/" class="md-nav__link">
        Eclipse client
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/other-languages/" class="md-nav__link">
        Cross-language clients
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/file-config/" class="md-nav__link">
        File-based configuration
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/logging/" class="md-nav__link">
        Logging
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_5" type="checkbox" id="__nav_5" >
      
      
      
      
        <label class="md-nav__link" for="__nav_5">
          Developers
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Developers" data-md-level="1">
        <label class="md-nav__title" for="__nav_5">
          <span class="md-nav__icon md-icon"></span>
          Developers
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/run-from-source/" class="md-nav__link">
        Run GUI from source
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/server-from-source/" class="md-nav__link">
        Run Server from source
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/plain-maven/" class="md-nav__link">
        Build with plain Maven
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/website/" class="md-nav__link">
        Work on the website
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_6" type="checkbox" id="__nav_6" >
      
      
      
      
        <label class="md-nav__link" for="__nav_6">
          Community
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Community" data-md-level="1">
        <label class="md-nav__title" for="__nav_6">
          <span class="md-nav__icon md-icon"></span>
          Community
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://www.eclipse.org/forums/index.php/f/442/" class="md-nav__link">
        Forum
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/-/issues/new" class="md-nav__link">
        File a bug
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/-/issues" class="md-nav__link">
        Open bugs
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://ci.eclipse.org/hawk/" class="md-nav__link">
        Builds
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    <li class="md-nav__item">
      <a href="../../additional-resources/" class="md-nav__link">
        Additional resources
      </a>
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              
              <div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#components" class="md-nav__link">
    Components
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#general-usage" class="md-nav__link">
    General usage
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#managing-indexes-with-the-hawk-view" class="md-nav__link">
    Managing indexes with the Hawk view
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#creating-a-new-index" class="md-nav__link">
    Creating a new index
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#managing-metamodels" class="md-nav__link">
    Managing metamodels
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#managing-repositories" class="md-nav__link">
    Managing repositories
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#managing-indexed-attributes" class="md-nav__link">
    Managing indexed attributes
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#managing-derived-attributes-and-references" class="md-nav__link">
    Managing derived attributes and references
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#querying-the-graph" class="md-nav__link">
    Querying the graph
  </a>
  
    <nav class="md-nav" aria-label="Querying the graph">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#resolving-ambiguous-names" class="md-nav__link">
    Resolving ambiguous names
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#limiting-query-scope" class="md-nav__link">
    Limiting query scope
  </a>
  
    <nav class="md-nav" aria-label="Limiting query scope">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#path-based-scope" class="md-nav__link">
    Path-based scope
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#tree-based-scope" class="md-nav__link">
    Tree-based scope
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#traversal" class="md-nav__link">
    Traversal
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          
            <div class="md-content" data-md-component="content">
              <article class="md-content__inner md-typeset">
                
                  


<h1 id="core-concepts-and-general-usage">Core concepts and general usage<a class="headerlink" href="#core-concepts-and-general-usage" title="Permanent link">&para;</a></h1>
<h2 id="components">Components<a class="headerlink" href="#components" title="Permanent link">&para;</a></h2>
<p>Hawk is an extensible system. Currently, it contains the following kinds of components:</p>
<table>
<thead>
<tr>
<th>Type</th>
<th>Role</th>
<th>Current implementations</th>
</tr>
</thead>
<tbody>
<tr>
<td>Change listeners</td>
<td>React to changes in the graph produced by the updaters</td>
<td>Tracing, Validation</td>
</tr>
<tr>
<td>Graph backends</td>
<td>Integrate database technologies</td>
<td><a href="http://neo4j.com/">Neo4j</a>, <a href="http://orientdb.com/">OrientDB</a>, <a href="https://greycat.ai/doc/">Greycat</a>, <a href="https://www.sqlite.org/">SQLite</a></td>
</tr>
<tr>
<td>Model drivers</td>
<td>Integrate modelling technologies</td>
<td><a href="https://eclipse.org/modeling/emf/">EMF</a>, <a href="https://www.modelio.org/">Modelio</a>, <a href="http://www.buildingsmart-tech.org/specifications/ifc-overview">IFC2x3/IFC4</a> in <a href="https://github.com/mondo-project/mondo-hawk-ifc">this repo</a>, and <a href="https://wiki.eclipse.org/MDT/UML2">UML2</a></td>
</tr>
<tr>
<td>Query languages</td>
<td>Translate high-level queries into efficient graph queries</td>
<td><a href="http://www.eclipse.org/epsilon/doc/eol/">Epsilon Object Language</a>, <a href="https://www.eclipse.org/epsilon/doc/epl/">Epsilon Pattern Language</a>, <a href="https://orientdb.com/docs/2.2/SQL.html">OrientDB SQL</a></td>
</tr>
<tr>
<td>Updaters</td>
<td>Update the graph based on the detected changes in the models and metamodels</td>
<td>Built-in</td>
</tr>
<tr>
<td>VCS managers</td>
<td>Integrate file-based model repositories</td>
<td>Local folders, <a href="https://subversion.apache.org/">SVN</a> repositories, <a href="https://git-scm.com/">Git</a> repositories, Eclipse workspaces, HTTP files</td>
</tr>
</tbody>
</table>
<h2 id="general-usage">General usage<a class="headerlink" href="#general-usage" title="Permanent link">&para;</a></h2>
<p>Using Hawk generally involves these steps:</p>
<ol>
<li>Create a new Hawk index, based on a specific backend (e.g. Neo4j or OrientDB).</li>
<li>Add the required metamodels to the index.</li>
<li>Add the model repositories to be monitored.</li>
<li>Wait for the initial batch insert (may take some time in large repositories).</li>
<li>Add the desired indexed and derived attributes.</li>
<li>Perform fast and efficient queries on the graph, using one of the supported query languages (see table above).</li>
</ol>
<p>In the following sections, we will show how to perform these steps.</p>
<h2 id="managing-indexes-with-the-hawk-view">Managing indexes with the Hawk view<a class="headerlink" href="#managing-indexes-with-the-hawk-view" title="Permanent link">&para;</a></h2>
<p>To manage and use Hawk indexes, first open the "Hawk" Eclipse view, using "Window &gt; Show View &gt; Other... &gt; Hawk &gt; Hawk". It should look like this:</p>
<p><img alt="Hawk view in Eclipse" src="../img/hawk_view.png" /></p>
<p>Hawk indexes are queried and managed from this view. From left to right, the buttons are:</p>
<ul>
<li>Query: opens the query dialog.</li>
<li>Run: starts a Hawk index if it was stopped.</li>
<li>Stop: stops a Hawk index if it was running.</li>
<li>Sync: request the Hawk index to check the indexed repositories immediately.</li>
<li>Delete: removes an index from the Hawk view, without deleting the actual database (it can be recovered later using the "Import" button). To remove a local index completely, select it and press <code>Shift+Delete</code>.</li>
<li>New: creates a new index (more info below).</li>
<li>Import: imports a Hawk index from a factory. Hawk itself only provides a "local" factory that looks at the subdirectories of the current Eclipse workspace.</li>
<li>Configure: opens the index configuration dialog, which allows for managing the registered metamodels, the repositories to be indexed, the attributes to be derived and the attributes to be indexed.</li>
</ul>
<h2 id="creating-a-new-index">Creating a new index<a class="headerlink" href="#creating-a-new-index" title="Permanent link">&para;</a></h2>
<p>To create a new index, open the Hawk view and use the "New" button to open this dialog:</p>
<p><img alt="New Hawk index creation dialog - Base Configuration tab" src="../img/new_hawk.png" /></p>
<p>The "Base Configuration" tab of this dialog contains these fields:</p>
<ul>
<li>Name: a descriptive name for the index. Only used as an identifier.</li>
<li>Instance type: you can use a local instance, or an instance hosted in an external server. By default, Hawk only indexes the latest version of the model, but you can also make it operate in a <a href="../../advanced-use/temporal-queries/">time-aware manner</a> mode) where it will record all versions of the model into a temporal graph.</li>
<li>Local storage folder: folder that will store the actual database (in local instances), or a reference to the remote server (in remote instances). If the folder exists, Hawk will reuse that database instead of creating a new one.</li>
<li>Remote location: only used for the remote instances.</li>
<li>Back-end: database backend to be used (note that only some backends support time-aware operation: please see <a href="../../advanced-use/temporal-queries/">here</a> for details).</li>
<li>Min/max delay: minimum and maximum delays in milliseconds between synchronisations. Hawk will start at the minimum value: every time it does not find any changes, it will double the delay up to the maximum value. If it finds a change, it will reset back to the minimum value. Periodic synchronisation can be completely disabled by changing the minimum and maximum delays to 0: in this mode, Hawk will only synchronise on startup, when a repository is added or when the user requests it manually.</li>
</ul>
<p>The "Advanced" tab of this dialog allows you to select which Hawk plugins to enable for this instance:</p>
<p><img alt="New Hawk index creation dialog - Advanced tab" src="../img/new_hawk_advanced.png" /></p>
<p>By default, local instances will have all metamodel parsers, all model parsers, and all query engines enabled out of the box. Remote instances will have no plugins enabled by default.</p>
<p>Since Hawk 2.2.0, the dialog requires selecting at least one metamodel parser, one model parser, and one query engine.</p>
<p>Once all settings are to your liking, click on "Finish" and Hawk will create and set up the index.</p>
<h2 id="managing-metamodels">Managing metamodels<a class="headerlink" href="#managing-metamodels" title="Permanent link">&para;</a></h2>
<p>After creating the index, the next step is to register the metamodels of the models that are going to be indexed. To do this, select the index in the Hawk view and either double click it or click on the "Configure" button. The configure dialog will open:</p>
<p><img alt="Hawk configure dialog" src="../img/hawk_metamodels.png" /></p>
<p>The configure dialog has several tabs.
For managing metamodels, we need to go to the "Metamodels" tab.
It will list the URIs of the currently registered metamodels.
Hawk will automatically try to register the necessary metamodels when it first encounters them in a model, so long as they are in the global EMF package registry.
If the metamodel is not in the global EMF package registry, or if you would like to set up all metamodels in advance, you can use one of the "Add" buttons:</p>
<ul>
<li><code>Add from filesystem...</code> will ask for the path to a file containing the metamodel in your computer (e.g. the <code>.ecore</code> file for EMF-based models, or the <code>metamodel-descriptor.xml</code> for Modelio-based models).</li>
<li><code>Add from registry...</code> allows you to search for a EPackage in the global EMF registry by namespace URI.</li>
<li><code>Add from workspace...</code> will ask for the location of a file containing the metamodel in your Eclipse workspace.</li>
</ul>
<p>We can also "Remove" metamodels: this will remove all dependent models and metamodels as well.</p>
<p>To try out Hawk, we recommend adding the <code>JDTAST.ecore</code> and <code>XMLType.ecore</code> metamodels in <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/-/tree/master/core/tests/org.eclipse.hawk.integration.tests/resources/metamodels">this folder</a>, which were used in the <a href="https://web.imt-atlantique.fr/x-info/atlanmod/index.php?title=GraBaTs_2009_Case_Study">GraBaTs 2009 case study from AtlanMod</a>. For Modelio metamodels, use the <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/-/blob/master/core/tests/org.eclipse.hawk.modelio.exml.tests/resources/metamodel/metamodel_descriptor.xml">metamodel-descriptor.xml</a> in the Hawk test suite for Modelio 3.6 projects (for other versions, use the older descriptors included as <code>metamodel_*.xml</code> files in the Modelio <a href="https://github.com/ModelioOpenSource/Modelio/tree/master/modelio/core/core.metamodel.impl/res/migration">sources</a>).</p>
<p>Keep in mind that metamodels may have dependencies to others. You will need to either add all metamodels at once, or add each metamodel after those it depends upon.</p>
<h2 id="managing-repositories">Managing repositories<a class="headerlink" href="#managing-repositories" title="Permanent link">&para;</a></h2>
<p>Having added the metamodels of the models to be indexed, the following step is to add the repositories to be indexed. To do so, go to the "Indexed Locations" tab of the Hawk configure dialog, and use the "Add" button. Hawk will present the following dialog:</p>
<p><img alt="Hawk add repository dialog" src="../img/hawk_add_repo.png" /></p>
<p>The fields will depend on the type of repository being added.
For example, for "Git Repository", you will be asked for the path to the local clone, and the branch to be indexed.
Other repositories may allow for entering a username/password pair (which will be stored on the Eclipse secure storage), or may ask for paths to individual files.</p>
<p>You can also tick the "Freeze repo" tick to temporarily prevent Hawk from checking the contents of a repository. This setting can be later changed by selecting the repository entry and clicking on "Edit...".</p>
<p>To try out Hawk, after adding the <code>JDTAST.ecore</code> and <code>XMLType.ecore</code> metamodels from the previous section, we recommend adding a "Local File Monitor" pointing to this <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/-/raw/master/core/tests/org.eclipse.hawk.integration.tests/resources/models/set0/set0.xmi"><code>set0.xmi</code></a> file. It has around 70k model elements. To watch over the indexing process, check the "Info" column in the Eclipse Hawk view.</p>
<p>The supported file extensions are as follows:</p>
<table>
<thead>
<tr>
<th>Driver</th>
<th>Extensions</th>
</tr>
</thead>
<tbody>
<tr>
<td>EMF</td>
<td><code>.xmi</code>, <code>.model</code>, any extensions in the EMF extension factory map, any extensions mentioned through the <code>org.eclipse.hawk.emf.model.extraExtensions</code> Java system property (e.g. <code>-Dorg.eclipse.hawk.emf.model.extraExtensions=.railway,.rail</code>).</td>
</tr>
<tr>
<td>UML2</td>
<td><code>.uml</code>. <code>.profile.uml</code> files can be indexed normally and also registered as metamodels.</td>
</tr>
<tr>
<td>BPMN</td>
<td><code>.bpmn</code>, <code>.bpmn2</code>.</td>
</tr>
<tr>
<td>Modelio</td>
<td><code>.exml</code>, <code>.ramc</code>. Parses <code>mmversion.dat</code> internally for metadata.</td>
</tr>
<tr>
<td>IFC</td>
<td><code>.ifc</code>, <code>.ifcxml</code>, <code>.ifc.txt</code>, <code>.ifcxml.txt</code>, <code>.ifc.zip</code>, <code>.ifczip</code>.</td>
</tr>
</tbody>
</table>
<h2 id="managing-indexed-attributes">Managing indexed attributes<a class="headerlink" href="#managing-indexed-attributes" title="Permanent link">&para;</a></h2>
<p>Simply indexing the models into the graph will already speed up considerably some common queries, such as finding all the instances of a type: in Hawk, this is done through direct edge traversal instead of going through the entire model. However, queries that filter model elements through the value of their attributes will need additional indexing to be set up.</p>
<p>For instance, if we wanted to speed up <code>return IJavaProject.all.selectOne(p|p.elementName='MyProject');</code> (which returns the Java project named "MyProject"), we would need to index the <code>elementName</code> attribute in the <code>IJavaProject</code> type. To do so, we need to go to the Hawk configure dialog, select the "Indexed Attributes" tab and press the "Add" button. This dialog will open:</p>
<p><img alt="Hawk dialog for adding indexed attributes" src="../img/hawk_add_indexed.png" /></p>
<p>Its fields are as follows:</p>
<ul>
<li>Metamodel URI: the URI of the metamodel that has the type we want.</li>
<li>Target Type: the name of the type (here "IJavaProject").</li>
<li>Attribute Name: the name of the attribute to be indexed (here "elementName").</li>
</ul>
<p>Please allow some time after the dialog is closed to have Hawk generate the index.</p>
<p>Currently, Hawk can index attributes with strings, booleans and numbers.
Indexing will speed up not only <code>=</code>, but also <code>&gt;</code> and all the other relational operators.</p>
<h2 id="managing-derived-attributes-and-references">Managing derived attributes and references<a class="headerlink" href="#managing-derived-attributes-and-references" title="Permanent link">&para;</a></h2>
<p>Sometimes we will need to filter model elements through a piece of information that is not directly stored among its attributes, but is rather computed from them.
To speed up the process, Hawk can maintain precomputed and indexed values for these <em>derived attributes</em> in the graph.
A derived attribute can contain a scalar value (an integer, a floating-point number, a boolean, or a string), or a collection of scalar values.</p>
<p>In other cases, we may want to maintain derived relationships between model elements, which were not reflected in the original model.
Hawk can use the same functionality to automatically maintain these <em>derived references</em>, which can speed up later queries.</p>
<p>For instance, if we wanted to quickly filter UML classes by their number of operations, we would go to the Hawk configure dialog, select the "Derived Attributes" tab and click on the "Add" button. This dialog would appear:</p>
<p><img alt="Hawk dialog for adding derived attributes" src="../img/hawk_add_derived.png" /></p>
<p>The fields are as follows:</p>
<ul>
<li>Metamodel URI: the URI of the metamodel with the type to be extended.</li>
<li>Type Name: the name of the type we are going to extend.</li>
<li>Attribute Name: the name of the new derived attribute (should be unique).</li>
<li>Attribute Type: the type of the new derived attribute.</li>
<li>isMany: true if this is a collection of values, false otherwise.</li>
<li>isOrdered: true if this is an ordered collection of values, false otherwise.</li>
<li>isUnique: true if the value should provide a unique identifier, false otherwise.</li>
<li>Derivation Language: query language that the derivation logic will be written on. <a href="http://www.eclipse.org/epsilon/doc/eol/">EOL</a> is the default choice.</li>
<li>Derivation Logic: expression in the chosen language that will compute the value.<ul>
<li>For a particularly long expression, it is best to write it in a separate <code>.eol</code> file and use the "Load from workspace..." button to load it into the field.</li>
<li>Hawk provides the <code>self</code> variable to access the model element being extended.</li>
<li>If the computed value is a scalar value or a collection of scalar values, Hawk will create a derived attribute. On the other hand, if the computed value is a model element or a collection of model elements, Hawk will create a derived reference.</li>
</ul>
</li>
</ul>
<p>For this particular example, we'd set the fields like this:</p>
<ul>
<li>Metamodel URI: the URI of the UML metamodel.</li>
<li>Type Name: Class.</li>
<li>Attribute Name: ownedOperationCount.</li>
<li>Attribute Type: Integer.</li>
<li>isMany, isOrdered, isUnique: false.</li>
<li>Derivation Language: EOLQueryEngine.</li>
<li>Derivation Logic: <code>return self.ownedOperation.size;</code>.</li>
</ul>
<p>After pressing OK, Hawk will spend some time computing the derived attribute and indexing the value. After that, queries such as <code>return Class.all.select(c|c.ownedOperationCount &gt; 20);</code> will complete much faster.</p>
<h2 id="querying-the-graph">Querying the graph<a class="headerlink" href="#querying-the-graph" title="Permanent link">&para;</a></h2>
<p>To query the indexed models, use the "Query" button of the Hawk view. This dialog will open:</p>
<p><img alt="Hawk query dialog" src="../img/query_hawk.png" /></p>
<p>The actual query can be entered through the "Query" field manually, loaded from a file using the "Query File" button, or loaded from the currently open editor through "Query Current Editor". The query should be written in the language selected in "Query Engine".</p>
<p>Running the query with "Run Query" button will place the results on the "Result" field.</p>
<h3 id="resolving-ambiguous-names">Resolving ambiguous names<a class="headerlink" href="#resolving-ambiguous-names" title="Permanent link">&para;</a></h3>
<p>In some cases, you may have registered multiple metamodels (with different namespace URIs) that contain types with the same name (e.g. two metamodels may define a <code>Class</code> type).
One solution is to use <code>`namespace`::Class</code>, but this may be unwieldy if you need to refer to the same type multiple times.</p>
<p>Alternatively, you can list <code>namespace</code> in the "Default Namespaces" field of the "Namespaces" tab.
This field takes a list of comma-separated namespaces, which will be tried in that order to resolve types without explicit namespaces.</p>
<h3 id="limiting-query-scope">Limiting query scope<a class="headerlink" href="#limiting-query-scope" title="Permanent link">&para;</a></h3>
<p>By default, the query covers all files indexed across all repositories.
This can be controlled in several ways, using the options in the "Path-based scope", "Tree-based scope", and "Traversal" tabs.</p>
<h4 id="path-based-scope">Path-based scope<a class="headerlink" href="#path-based-scope" title="Permanent link">&para;</a></h4>
<p><img alt="Hawk query dialog - path-based scopes" src="../img/query_hawk_path_scope.png" /></p>
<p>One option is to limit the set of repositories and files that will report results through the query.
Both <code>Context Repositories</code> and <code>Context Files</code> can take a comma-separated list of patterns, which can use "*" as a wildcard for zero or more characters.</p>
<p>It is also possible to change how Hawk traverses the graph to find all the instances of a type.
If the <code>Start with files</code> box is checked, Hawk will first find the matching repositories and files and then filter their contents by type, instead of finding all the instances of the type and filtering them by file and repository.
This can be faster if only a small subset of the files should be traversed within a very large fragmented model.</p>
<h4 id="tree-based-scope">Tree-based scope<a class="headerlink" href="#tree-based-scope" title="Permanent link">&para;</a></h4>
<p><img alt="Hawk query dialog - tree-based scope" src="../img/query_hawk_tree_scope.png" /></p>
<p>Instead of path-based scope, tree-based scope can be used to take advantage of the containment relationships already present in models that are fragmented (i.e. broken up into multiple files).</p>
<p>Suppose that you have a folder like this:</p>
<ul>
<li><code>/root.xmi</code>: root model fragment representing the whole system.</li>
<li><code>/a/component.xmi</code>: model fragment for a component within the system.</li>
<li><code>/a/b/subcomponent.xmi</code>: model fragment for a subcomponent within the system.</li>
</ul>
<p>You can use <code>/a/component.xmi</code> in the "Subtree root context" to limit the query to only the model elements within that component.</p>
<p>If you tick "Use derived edges", when querying <code>YourType.all</code> Hawk will automatically extend the type of the root element of the subtree root context with <code>allof_YourType</code> derived references to speed up later queries.</p>
<h4 id="traversal">Traversal<a class="headerlink" href="#traversal" title="Permanent link">&para;</a></h4>
<p>By default, the above scopes only limit what is returned from <code>Type.all</code> queries: they do not prevent a query from "escaping" its original scope by following references, for performance reasons.</p>
<p>If you would like to ensure that all references are limited to the specified scope, tick the "Enabled Full Traversal Scoping" option.
This may have a significant effect in performance, as it will require following several other edges for every reference being followed.</p>





                
              </article>
            </div>
          
          
        </div>
        
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
          <a href="../installation/" title="Installation" class="md-flex md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-back md-footer-nav__button"></i>
            </div>
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                Installation
              </span>
            </div>
          </a>
        
        
          <a href="../examples-xmi/" title="Examples (XMI)" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                Examples (XMI)
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
          <div class="md-footer-copyright__highlight">
            Copyright © Eclipse Foundation, Inc. All Rights Reserved.
          </div>
        
        powered by
        <a href="https://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">Material for MkDocs</a>
      </div>
      <div class="md-footer-copyright hawk-eclipse-links">
          <ul>
              <li><a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a></li>
              <li><a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a></li>
              <li><a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a></li>
          </ul>
      </div>
      <div class="md-social">
  
</div>
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    
    <script id="__config" type="application/json">{"base": "../..", "features": [], "search": "../../assets/javascripts/workers/search.5bf1dace.min.js", "translations": {"clipboard.copied": "Copied to clipboard", "clipboard.copy": "Copy to clipboard", "search.config.lang": "en", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "Search", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.placeholder": "Type to start searching", "search.result.term.missing": "Missing", "select.version.title": "Select version"}}</script>
    
    
      <script src="../../assets/javascripts/bundle.078830c0.min.js"></script>
      
    
  </body>
</html>